/*
     []------------------------------------------------------------------[]
     |                              ACT.C                                 |
     |                                                                    |
     |          "Desacentua" mensagens recebidas via e-mail               |
     |                                                                    |
     |	                (C) 1997, Lenimar N. Andrade                      |
     []------------------------------------------------------------------[]
*/

#include "str.c"

/* ------------------------------------------------------------------------- */

void SubstituiCaracter(char *linha) {

char aagudo[3] = "", eagudo[3] = "", iagudo[3] = "", oagudo[3] = "",
     uagudo[3] = "", Aagudo[3] = "", Eagudo[3] = "", Iagudo[3] = "",
     Oagudo[3] = "", Uagudo[3] = "", atil[3] = "", otil[3] = "",
     Atil[3] = "", Otil[3] = "", acrase[3] = "", Acrase[3] = "",
     utrema[3] = "", Utrema[3] = "", acirc[3] = "", ecirc[3] = "",
     ocirc[3] = "", Acirc[3] = "", Ecirc[3] = "", Ocirc[3] = "",
     ccedil[3] = "", Ccedil[3] = "", ntil[3] = "", Ntil[3] = "";

  Substitui(linha, aagudo, "a'"); /* a agudo */
  Substitui(linha, eagudo, "e'"); /* e agudo */
  Substitui(linha, iagudo, "i'"); /* i agudo */
  Substitui(linha, oagudo, "o'"); /* o agudo */
  Substitui(linha, uagudo, "u'"); /* u agudo */
  Substitui(linha, Aagudo, "A'"); /* A agudo */
  Substitui(linha, Eagudo, "E'"); /* E agudo */
  Substitui(linha, Iagudo, "I'"); /* I agudo */
  Substitui(linha, Oagudo, "O'"); /* O agudo */
  Substitui(linha, Uagudo, "U'"); /* U agudo */
  Substitui(linha, ccedil, ",c"); /* c cedilha */
  Substitui(linha, Ccedil, ",C"); /* C cedilha */
  Substitui(linha, atil, "~a"); /* a til */
  Substitui(linha, otil, "~o"); /* o til */
  Substitui(linha, Atil, "~A"); /* A til */
  Substitui(linha, Otil, "~O"); /* O til */
  Substitui(linha, acirc, "^a"); /* a circunflexo */
  Substitui(linha, ecirc, "^e"); /* e circunflexo */
  Substitui(linha, ocirc, "^o"); /* o circunflexo */
  Substitui(linha, Acirc, "^A"); /* A circunflexo */
  Substitui(linha, Ecirc, "^E"); /* E circunflexo */
  Substitui(linha, Ocirc, "^O"); /* O circunflexo */
  Substitui(linha, utrema, "\"u"); /* u trema */
  Substitui(linha, Utrema, "\"U"); /* U trema */
  Substitui(linha, acrase, "`a"); /* a craseado */
  Substitui(linha, Acrase, "`A"); /* A craseado */
  Substitui(linha, ntil, "~n");   /* n til */
  Substitui(linha, Ntil, "~N");   /* N til */

  if (Pos('=', linha) >= 0) {
    Substitui(linha, "=E1", "a'"); /* a agudo */
    Substitui(linha, "=E9", "e'"); /* e agudo */
    Substitui(linha, "=ED", "i'"); /* i agudo */
    Substitui(linha, "=F3", "o'"); /* o agudo */
    Substitui(linha, "=FA", "u'"); /* u agudo */
    Substitui(linha, "=C1", "A'"); /* A agudo */
    Substitui(linha, "=C9", "E'"); /* E agudo */
    Substitui(linha, "=CD", "I'"); /* I agudo */
    Substitui(linha, "=D3", "O'"); /* O agudo */
    Substitui(linha, "=DA", "U'"); /* U agudo */
    Substitui(linha, "=E7", ",c"); /* c cedilha */
    Substitui(linha, "=C7", ",C"); /* C cedilha */
    Substitui(linha, "=E3", "~a"); /* a til */
    Substitui(linha, "=F5", "~o"); /* o til */
    Substitui(linha, "=C3", "~A"); /* A til */
    Substitui(linha, "=D5", "~O"); /* O til */
    Substitui(linha, "=E2", "^a"); /* a circunflexo */
    Substitui(linha, "=EA", "^e"); /* e circunflexo */
    Substitui(linha, "=F4", "^o"); /* o circunflexo */
    Substitui(linha, "=C2", "^A"); /* A circunflexo */
    Substitui(linha, "=CA", "^E"); /* E circunflexo */
    Substitui(linha, "=D4", "^O"); /* O circunflexo */
    Substitui(linha, "=FC", "\"u"); /* u trema */
    Substitui(linha, "=DC", "\"U"); /* U trema */
    Substitui(linha, "=E0", "`a"); /* a craseado */
    Substitui(linha, "=C0", "`A"); /* A craseado */
    Substitui(linha, "=20", " "); /* espaco em branco */
    Substitui(linha, "=3D", "="); /* igual */
    Substitui(linha, "=F1", "~n"); /* n til */
    Substitui(linha, "=D1", "~N");  /* N til */
  }

}

/* ------------------------------------------------------------------------- */

int LeLinhaEmArquivo(char *nome_arq, char *nome_destino) {

  FILE *arq, *arq_dest;
  static char linha[10000];
  int quant, ch;

  if ((arq = fopen(nome_arq, "rb")) == NULL) return 0;
  if ((arq_dest = fopen(nome_destino, "wt")) == NULL) return 0;

  do {
    quant = 0;
    do {
      ch = getc(arq);
      if (ch != '\0' && ch >= 0 && ch != 10 && ch != 13) {
	linha[quant++] = ch;
      }
    } while (ch != 13 && ch >= 0);
    if (ch >= 0 || quant == 0)
      linha[quant] = '\0';
    else
      linha[quant - 1] = '\0';

    SubstituiCaracter(linha);
    fprintf(arq_dest, "\n%s", linha);

  } while (ch >= 0);

  fclose(arq);
  fclose(arq_dest);
  return 1;
}

/* ------------------------------------------------------------------------- */

int Unix(char *nome_arq) {

  FILE *arq;
  int unix = 0, cont = 0, quant = 5000, ch, ch_anterior;

  if ((arq = fopen(nome_arq, "rb")) == NULL) return 0;

  ch_anterior = getc(arq);
  do {
    ch = getc(arq);
    if (ch == 10 && ch_anterior != 13) { fclose(arq); return 1; }
    ch_anterior = ch;
  } while (cont++ < quant);
  fclose(arq);
  return unix;
}

/* ------------------------------------------------------------------------- */

void main(int argc, char *argv[]) {

  char nome_origem[80], nome_destino[80];

  if (argc < 2) {
    printf("\n*** Coloca acentos ao lado das letras ***");
    printf("\n\nForma de usar: ACT arq_origem arq_destino\n");
    return;
  }

  strcpy(nome_origem, argv[1]);
  strcpy(nome_destino, argv[2]);

  if (Unix(nome_origem)) {
    printf("\n\aERRO: o texto esta' no formato do Unix\n");
    return;
  }

 LeLinhaEmArquivo(nome_origem, nome_destino);

}
